# Project: demo of interactive graphics with esetVis, ggvis and shiny
# 
# Author: Laure Cougnaud
###############################################################################

cat("server \n")

shinyServer(function(input, output, session){
				
	outputAnalysis <- reactive({
		switch(input$typePlot,
			'1' = spectralMapALL, '2' = tsneALL, '3' = ldaALL
		)
	})

	#output$esetPlot <- renderPlot({
	observe({
				
		str(input$tooltipExtraVars)
	
		dataPlot <- outputAnalysis()$analysis		
				
		argsEsetPlotWrapper <- c(
			list(
				dataPlotSamples = dataPlot$dataPlotSamples,
				esetUsed = dataPlot$esetUsed,
				title = paste(
					switch(input$typePlot, '1' = "Spectral map", 
						'2' = "Tsne", '3' = "Linear discriminant analysis"),
						"of the ALL dataset"
				),
				typePlot = "interactive"
			),
			if("dataPlotGenes" %in% names(dataPlot))
				list(dataPlotGenes = dataPlot$dataPlotGenes)	else NULL,
			if("axisLabels" %in% names(dataPlot))
				list(xlab = dataPlot$axisLabels[1], ylab = dataPlot$axisLabels[2])	else NULL,
			if(!is.null(input$colPlot))
				list(colorVar = input$colPlot)	else NULL,
			if(!is.null(input$shapePlot))
				list(shapeVar = input$shapePlot)	else NULL,
			if(!is.null(input$sizePlot))
				list(sizeVar = input$sizePlot)	else NULL,
			if(!is.null(input$nTopgene))
				list(topGenes = input$nTopgene)	else NULL,
			if(!is.null(input$vargene))
				list(topGenesVar = input$vargene)	else NULL,
			if(!is.null(input$nTopsample))
				list(topSamples = input$nTopsample)	else NULL,
			if(!is.null(input$varsample))
				list(topSamplesVar = input$varsample)	else NULL,
			if(!is.null(input$tooltipExtraVars))
				list(ggvisTooltipExtraVars = input$tooltipExtraVars)	else NULL
		)
		
		str(argsEsetPlotWrapper)
		str(class(input$tooltipExtraVars))
		str(input$tooltipExtraVars)
				
		do.call("esetPlotWrapper", argsEsetPlotWrapper) %>%
			bind_shiny("esetPlotGGvis", "esetPlotGGvis_ui")
				
	})
			
			
})
